#include "World.h"
#include "OgreMath.h"
#include "OgreSceneManager.h"
#include "OgreSceneNode.h"
#include "OgreVector3.h"
#include "OgreAnimationState.h"
#include "OgreAnimation.h"
#include "OgreEntity.h"

using namespace Ogre;

World::World(Ogre::SceneManager *sceneManager) : mSceneManager(sceneManager)
{
    zeroFrames = 0;
    nonZeroFrames = 0;
    mSceneManager->setAmbientLight(ColourValue(1,1,1));
    Setup();
}

void World::Setup()
{
    mInchwormEntity = mSceneManager->createEntity("worm.mesh");
    mIncrwormNode = mSceneManager->getRootSceneNode()->createChildSceneNode();
    mIncrwormNode->attachObject(mInchwormEntity);
    mIncrwormNode->setPosition(20, 20, 0);
    mIncrwormNode->roll(Ogre::Degree(90));
    mIncrwormNode->yaw(Ogre::Degree(90));

    mInchwormEntity2 = mSceneManager->createEntity("worm.mesh");
    mIncrwormNode2 = mSceneManager->getRootSceneNode()->createChildSceneNode();
    mIncrwormNode2->attachObject(mInchwormEntity2);
    mIncrwormNode2->yaw(Ogre::Degree(90));


    mInchwormEntity->getAnimationState("Inch")->setEnabled(true);
    mInchwormEntity->getAnimationState("Inch")->setLoop(true);
    mInchwormEntity->getAnimationState("Inch")->setWeight(1.0);

    mInchwormEntity2->getAnimationState("Wave")->setEnabled(true);
    mInchwormEntity2->getAnimationState("Wave")->setLoop(true);
    mInchwormEntity2->getAnimationState("Wave")->setWeight(1.0); 

    // There is also an animation InchMove associated with this model --
    //  replace Inch with InchMove and see what happens ...
}

void 
World::Think(float time)
{

    // Do other stuff

    Ogre::AnimationState *st2 = mInchwormEntity->getAnimationState("Inch");
    st2->addTime(time);
    Ogre::AnimationState * st = mInchwormEntity2->getAnimationState("Wave");
    st->addTime(time);
}


